﻿using UnityEngine;
using System.Collections;
using System;

public class CustomCollider2D : MonoBehaviour 
{
	public event Action <CustomCollider2D, Collision2D> onCollisionEnter;
	public event Action <CustomCollider2D, Collision2D> onCollisionExit;
	public event Action <CustomCollider2D, Collision2D> onCollisionStay;

	public event Action <CustomCollider2D, Collider2D> onTriggerEnter;
	public event Action <CustomCollider2D, Collider2D> onTriggerExit;
	public event Action <CustomCollider2D, Collider2D> onTriggerStay;

	void OnCollisionEnter2D(Collision2D collision) 
	{
		if (onCollisionEnter != null)
			onCollisionEnter(this, collision);		
	}
	void OnCollisionExit2D(Collision2D collision) 
	{
		if (onCollisionExit != null)
			onCollisionExit(this, collision);
	}
	void OnCollisionStay2D(Collision2D collision) 
	{
		if (onCollisionStay != null)
			onCollisionStay(this, collision);
	}
	void OnTriggerEnter2D(Collider2D collider) 
	{
		if (onTriggerEnter != null)
			onTriggerEnter(this, collider);
	}
	void OnTriggerExit2D(Collider2D collider) 
	{
		if (onTriggerExit != null)
			onTriggerExit(this, collider);
	}
	void OnTriggerStay2D(Collider2D collider) 
	{
		if (onTriggerStay != null)
			onTriggerStay(this, collider);
	}
}
