﻿using UnityEngine;
using System.Collections;

public class GlobalInfo : MonoBehaviour 
{
	#region Singleton
	static private GlobalInfo _instance;
	static public GlobalInfo GetInstance()
	{
		if(_instance == null)
		{
			_instance = new GameObject("GlobalInfo", typeof(GlobalInfo)).GetComponent<GlobalInfo>();

			if (_instance.colorReference == null)
				_instance.colorReference = Resources.Load<ColorReference>("Prefabs/ColorReference");

			GameObject.DontDestroyOnLoad(_instance);
			GameObject.DontDestroyOnLoad(_instance.colorReference);
		}	
		return _instance; 
	}
	#endregion

	public ColorReference	colorReference;
}
