﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;

public class PlayerColorGUISet : MonoBehaviour 
{
	public CanvasGroup	canvasGroup;


	public Image	centerColor;
	public Image	centerMaskColor;
	public Image	leftColor;
	public Image	leftMaskColor;
	public Image	rightColor;
	public Image	rightMaskColor;
	public ColorReference	colorReference;

	// Use this for initialization
	void Start () 
	{

		colorReference = GlobalInfo.GetInstance ().colorReference;

		if (name.StartsWith("Player1"))
		{
			centerColor.color = colorReference.colorList[0];
			leftColor.color = colorReference.colorList[2];
			rightColor.color = colorReference.colorList[1];
		}
		else
		{
			centerColor.color = colorReference.colorList[1];
			leftColor.color = colorReference.colorList[0];
			rightColor.color = colorReference.colorList[2];
		}
		//canvasGroup.alpha = 0.7f;
	}
	


	public void SetColors(ColorReference.Colors p_nextCenterColor, bool p_isRightToLeft)
	{
		centerColor.color = colorReference.colorList [(int)p_nextCenterColor];
		if (p_isRightToLeft)
		{
			if (p_nextCenterColor == ColorReference.Colors.BLUE)
			{
				centerMaskColor.color = colorReference.colorList[0];
				leftMaskColor.color = colorReference.colorList[2];
				leftColor.color = colorReference.colorList[0];
				rightMaskColor.color = colorReference.colorList[1];
				rightColor.color = colorReference.colorList[2];
			}
			else if (p_nextCenterColor == ColorReference.Colors.YELLOW)
			{
				centerMaskColor.color = colorReference.colorList[1];
				leftMaskColor.color = colorReference.colorList[0];
				leftColor.color = colorReference.colorList[1];
				rightMaskColor.color = colorReference.colorList[2];
				rightColor.color = colorReference.colorList[0];
			}
			else
			{
				centerMaskColor.color = colorReference.colorList[2];
				leftMaskColor.color = colorReference.colorList[1];
				leftColor.color = colorReference.colorList[2];
				rightMaskColor.color = colorReference.colorList[0];
				rightColor.color = colorReference.colorList[1];
			}
		}
		else
		{
			if (p_nextCenterColor == ColorReference.Colors.BLUE)
			{
				centerMaskColor.color = colorReference.colorList[2];
				leftMaskColor.color = colorReference.colorList[1];
				leftColor.color = colorReference.colorList[0];
				rightMaskColor.color = colorReference.colorList[0];
				rightColor.color = colorReference.colorList[2];
			}
			else if (p_nextCenterColor == ColorReference.Colors.RED)
			{
				centerMaskColor.color = colorReference.colorList[1];
				leftMaskColor.color = colorReference.colorList[0];
				leftColor.color = colorReference.colorList[2];
				rightMaskColor.color = colorReference.colorList[2];
				rightColor.color = colorReference.colorList[1];
			}
			else
			{
				centerMaskColor.color = colorReference.colorList[0];
				leftMaskColor.color = colorReference.colorList[2];
				leftColor.color = colorReference.colorList[1];
				rightMaskColor.color = colorReference.colorList[1];
				rightColor.color = colorReference.colorList[0];
			}
		}
		StartCoroutine(MoveImages(p_isRightToLeft));
	}
	IEnumerator MoveImages(bool p_rightToLeft)
	{
		Vector2 __center = new Vector2 ();
		Vector2 __left = new Vector2 ();
		Vector2 __right = new Vector2 ();

		if (p_rightToLeft)
		{
			__center = centerMaskColor.rectTransform.anchoredPosition + new Vector2(135f,0f);
			__left = leftMaskColor.rectTransform.anchoredPosition + new Vector2(95f,0f);
			__right = rightMaskColor.rectTransform.anchoredPosition + new Vector2(95f,0f);
		}
		else
		{
			__center = centerMaskColor.rectTransform.anchoredPosition + new Vector2(-135f,0f);
			__left = leftMaskColor.rectTransform.anchoredPosition + new Vector2(-95f,0f);
			__right = rightMaskColor.rectTransform.anchoredPosition + new Vector2(-95f,0f);
		}
		centerColor.rectTransform.anchoredPosition = __center;
		leftColor.rectTransform.anchoredPosition = __left;
		rightColor.rectTransform.anchoredPosition = __right;
		//yield return new WaitForSeconds (0.3f);
		float __t = 0f;
		while (__t < 1f)
		{
			__t += Time.deltaTime * 2.5f;
			//p_sr.color = Color.Lerp(p_from, __to, __t);
			centerColor.rectTransform.anchoredPosition = Vector2.Lerp(__center, centerMaskColor.rectTransform.anchoredPosition, __t);
			leftColor.rectTransform.anchoredPosition = Vector2.Lerp(__left, leftMaskColor.rectTransform.anchoredPosition, __t);
			rightColor.rectTransform.anchoredPosition = Vector2.Lerp(__right, rightMaskColor.rectTransform.anchoredPosition, __t);
			yield return null;
		}
		yield break;
	}
}
