﻿using UnityEngine;
using System.Collections;

public class AnimationManager : MonoBehaviour 
{
	public CoreManager	coreManager;
	public GameObject	centerCircleBG;
	public Camera		gameCamera;
	public CanvasGroup	player1GUISet;
	public CanvasGroup	player2GUISet;
	public CanvasGroup	mixedColorBar;

	public SpriteRenderer	player1;
	public SpriteRenderer	player2;
	// Use this for initialization
	public void LevelFinished()
	{

		StartCoroutine (ScaleCenterCircle ());
		StartCoroutine (ZoomCamera (CoreManager.levelInfo.fullImageCameraSize));
		StartCoroutine (FadeHUD());
		StartCoroutine (FadePlayer());
	}
	IEnumerator ZoomCamera(float p_size)
	{
		yield return new WaitForSeconds (8f);
		float __startSize = gameCamera.orthographicSize;
		Vector3 __startPos = coreManager.fullImage.transform.localPosition;
		float __t = 0f;
		while (__t < 1f)
		{
			__t += Time.deltaTime * 0.4f;
			gameCamera.orthographicSize = __startSize + ((p_size - __startSize) * __t);
			if (CoreManager.level != 0)
				coreManager.fullImage.transform.localPosition = Vector3.Lerp(__startPos, CoreManager.levelInfo.fullImagePositionEnd, __t);
			yield return null;
		}
		yield return new WaitForSeconds (3f);
		CoreManager.level ++;
		if (CoreManager.level == 4) 
		{
			CoreManager.level = 0;
			Application.LoadLevel ("TutorialScene");
		}
		Application.LoadLevel (Application.loadedLevelName);
		yield break;
	}
	IEnumerator FadePlayer()
	{
		yield return new WaitForSeconds (0.3f);
		float __t = 0f;
		Color __c = new Color ();
		while (__t < 1f)
		{
			__t += Time.deltaTime * 0.5f;
			__c = player1.color;
			__c.a = 1f - __t;
			player1.color = __c;
			__c = player2.color;
			__c.a = 1f - __t;
			player2.color = __c;
			yield return null;
		}
		yield break;
	}
	IEnumerator FadeHUD()
	{
		yield return new WaitForSeconds (0.3f);
		float __t = 0f;
		float __aP1 = player1GUISet.alpha;
		float __aP2 = player2GUISet.alpha;
		float __aMixed = mixedColorBar.alpha;

		while (__t < 1f)
		{
			__t += Time.deltaTime * 0.5f;
			player1GUISet.alpha = __aP1  * (1f - __t);
			player2GUISet.alpha = __aP2  * (1f - __t);
			mixedColorBar.alpha = __aMixed  * (1f - __t);
			yield return null;
		}
		yield break;
	}
	IEnumerator ScaleCenterCircle()
	{
		yield return new WaitForSeconds (3.3f);
		float __t = 0f;
		while (__t < 1f)
		{
			__t += Time.deltaTime * 0.4f;
			centerCircleBG.transform.localScale = Vector3.Lerp(Vector3.one, Vector3.one * 8f, __t);
			yield return null;
		}
		yield break;
	}
}
