﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class EnemyManager : MonoBehaviour 
{
	public GameObject	enemyContainer;
	public GameObject	enemyPrefab;
	public List<Enemy>	enemyList;

	public float 		spawn = 2.5f;
	public float 		spawnTimer = 0f;
	public List<int>	enemyTypeChance;
	public List<int>	enemyLayerChance;
	public bool			active = true;
	// Use this for initialization
	void Start () 
	{
		spawnTimer = 0f;
	}
	public void SetChances()
	{
		spawn = CoreManager.levelInfo.enemySpawnRate;
		enemyTypeChance = CoreManager.levelInfo.enemyTypeChance;
	}
	// Update is called once per frame
	void Update () 
	{
		if (!active)
			return;
		spawnTimer -= Time.deltaTime;
		if (spawnTimer <= 0f)
		{
			spawnTimer = spawn;
			SpawnEnemy ();
		}
	}

	public void SpawnEnemy()
	{
		GameObject __go = (GameObject)GameObject.Instantiate (enemyPrefab);
		__go.transform.SetParent (enemyContainer.transform);

		float __angle = (Random.Range (0f, 360f))* Mathf.Deg2Rad;
		__go.transform.localPosition = new Vector3 (Mathf.Cos (__angle), Mathf.Sin (__angle), Random.Range(-0.5f,0.5f)) * 10f;
		Enemy __enemy = __go.GetComponent<Enemy> ();
		enemyList.Add (__enemy);
		__enemy.OnEnemyDestroyed += DestroyEnemy;
		__enemy.SetAngle (__angle * Mathf.Rad2Deg);
		__enemy.SetSpeed (CoreManager.levelInfo.enemySpeed);
		float __random = Random.Range (0f, 100f);
		if (__random <= enemyTypeChance [0])
			__enemy.type = Enemy.EnemyType.SIMPLE;
		else if (__random <= enemyTypeChance [0] + enemyTypeChance [1])
			__enemy.type = Enemy.EnemyType.MIXED;
		else
		{
			__enemy.type = Enemy.EnemyType.LAYER;
			__random = Random.Range (0f, 100f);
			if (__random <= enemyLayerChance [0])
				__enemy.layers = 2;
			else if (__random <= enemyLayerChance [0] + enemyLayerChance [1])
				__enemy.layers = 3;
			else
				__enemy.layers = 4;
		}


	}
	public void SetActive(bool p_active)
	{
		active = true;
	}
	public void StopAndFadeEnemies()
	{
		active = false;
		foreach (Enemy __enemy in enemyList)
			__enemy.FadeEnemy ();
	}
	private void DestroyEnemy(Enemy p_enemy)
	{
		enemyList.Remove (p_enemy);
		Destroy (p_enemy.gameObject);
	}
}
