﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;

public class GUIManager : MonoBehaviour 
{
	public Image			mixedColor;
	public ColorReference	colorReference;

	public PlayerColorGUISet	player1GUISet;
	public PlayerColorGUISet	player2GUISet;
	// Use this for initialization
	void Start () 
	{
		colorReference = GlobalInfo.GetInstance ().colorReference;
	}
	
	// Update is called once per frame
	void Update () 
	{
	
	}
	public void ChangePlayerColor(ColorReference.Colors p_color, bool p_isP1, bool p_isRightToLeft)
	{
		if (p_isP1)
			player1GUISet.SetColors(p_color, p_isRightToLeft);
		else
			player2GUISet.SetColors(p_color, p_isRightToLeft);
	}
	public void UpdateMixedColor(ColorReference.Colors p_P1color, ColorReference.Colors p_P2color)
	{
		if (p_P1color == p_P2color)
			mixedColor.color = colorReference.colorList[(int)p_P1color];
		else if ((p_P1color == ColorReference.Colors.RED && p_P2color == ColorReference.Colors.BLUE) ||
		         (p_P1color == ColorReference.Colors.BLUE && p_P2color == ColorReference.Colors.RED))
			mixedColor.color = colorReference.colorList[(int)ColorReference.Colors.PURPLE];
		else if ((p_P1color == ColorReference.Colors.RED && p_P2color == ColorReference.Colors.YELLOW) ||
		         (p_P1color == ColorReference.Colors.YELLOW && p_P2color == ColorReference.Colors.RED))
			mixedColor.color = colorReference.colorList[(int)ColorReference.Colors.ORANGE];
		else if ((p_P1color == ColorReference.Colors.YELLOW && p_P2color == ColorReference.Colors.BLUE) ||
		         (p_P1color == ColorReference.Colors.BLUE && p_P2color == ColorReference.Colors.YELLOW))
			mixedColor.color = colorReference.colorList[(int)ColorReference.Colors.GREEN];

	}




}
