﻿using UnityEngine;
using System.Collections;

public class PlayerManager : MonoBehaviour 
{

	public Player player1;
	public Player player2;

	public GUIManager		guiManager;
	public ShootManager		shootManager;

	public bool				active;
	// Use this for initialization
	void Start () 
	{
		active = true;
		player1.SetAngle (180f);
		player1.SetColor (ColorReference.Colors.RED);
		player2.SetAngle (0f);
		player2.SetColor (ColorReference.Colors.BLUE);
		guiManager.UpdateMixedColor (player1.color, player2.color);
		GlobalInfo.GetInstance ();
	}
	
	// Update is called once per frame
	void Update () 
	{
		if (!active)
			return;
		//Movement
		if (Input.GetKey (KeyCode.A))
			player1.MovePlayer (false);
		else if (Input.GetKey (KeyCode.D))
			player1.MovePlayer (true);

		if (Input.GetKey (KeyCode.Keypad4))
			player2.MovePlayer (false);
		else if (Input.GetKey (KeyCode.Keypad6))
			player2.MovePlayer (true);

		//Shot
		if (Input.GetKey(KeyCode.S) || Input.GetKey(KeyCode.Space))
		{
			if (player1.GetShootCooldown())
			{
				player1.Shoot();
				shootManager.CreateShoot(player1.transform.position, player1.GetAngle(),1, player1.color);
			}
		}
		if (Input.GetKey(KeyCode.Keypad5) || Input.GetKey(KeyCode.KeypadEnter))
		{
			if (player2.GetShootCooldown())
			{
				player2.Shoot();
				shootManager.CreateShoot(player2.transform.position, player2.GetAngle(),2, player2.color);
			}
		}

		//Color Change
		if (Input.GetKey (KeyCode.Q) && player1.GetChangeColorCooldown ())
			ChangePlayerColor (true, false);
		else if (Input.GetKey (KeyCode.E) && player1.GetChangeColorCooldown ())
			ChangePlayerColor (true, true);

		if (Input.GetKey (KeyCode.Keypad7) && player2.GetChangeColorCooldown ())
			ChangePlayerColor (false, false);
		else if (Input.GetKey (KeyCode.Keypad9) && player2.GetChangeColorCooldown ())
			ChangePlayerColor (false, true);
	}
	public void EnablePlayers(bool p_enable)
	{
		active = p_enable;
	}
	private void ChangePlayerColor(bool p_isP1, bool p_isRight)
	{
		if (p_isP1)
		{
			player1.ChangeColor (p_isRight);
			guiManager.ChangePlayerColor(player1.color, true, p_isRight);
		}
		else
		{
			player2.ChangeColor (p_isRight);
			guiManager.ChangePlayerColor(player2.color, false, p_isRight);
		}
		guiManager.UpdateMixedColor (player1.color, player2.color);
	}
}
