﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class ShootManager : MonoBehaviour 
{
	public GameObject	shootsContainer;
	public GameObject	shootPrefab;
	public List<Shoot>  shootList;
	
	public void CreateShoot(Vector3 p_pos, float p_angle, int p_playerIndex, ColorReference.Colors p_color)
	{
		GameObject __go = (GameObject)GameObject.Instantiate (shootPrefab);
		__go.name = "Shoot";
		__go.transform.SetParent (shootsContainer.transform);
		__go.transform.localPosition = p_pos;
		Shoot __shoot = __go.GetComponent<Shoot> ();
		shootList.Add (__shoot);
		__shoot.SetAngle (p_angle);
		__shoot.OnDestroyShot += KillShoot;
		__shoot.playerIndex = p_playerIndex;
		__shoot.color = p_color;
	}

	private void KillShoot(Shoot p_shoot)
	{
		shootList.Remove (p_shoot);
		Destroy(p_shoot.gameObject);
	}
}
