﻿using UnityEngine;
using System.Collections;
using System;

public class Shoot : MonoBehaviour 
{
	public event Action<Shoot>	OnDestroyShot;
	[SerializeField]
	private float angle;
	private float rad;
	
	private float speed = 5f;
	private float killRange = 9f;

	public int						playerIndex = 0;
	public SpriteRenderer			spriteRenderer;
	public ColorReference.Colors	color;

	// Use this for initialization
	void Start () 
	{
		if (spriteRenderer == null)
			spriteRenderer = GetComponent<SpriteRenderer> ();
		spriteRenderer.color = GlobalInfo.GetInstance ().colorReference.colorList [(int)color];
	}
	
	// Update is called once per frame
	void Update () 
	{
		transform.localPosition += new Vector3 (Mathf.Cos  (rad), Mathf.Sin (rad), 0f) * speed * Time.deltaTime;

		if (Vector3.Magnitude (transform.localPosition) >= killRange)
			if (OnDestroyShot != null)
				OnDestroyShot (this);
	}

	public void SetAngle(float p_angle)
	{
		angle = p_angle;
		rad = Mathf.Deg2Rad * angle;
		transform.localRotation = Quaternion.Euler(new Vector3 (0f,0f, angle));
	}
	public void ShootHitEnemy()
	{
		if (OnDestroyShot != null)
			OnDestroyShot (this);
	}
}
